import c4d
from c4d import gui
import imp
import os
import warnings
import random
import time
warnings.filterwarnings("ignore")
dir, file = os.path.split(__file__)


count =0
stop = False
head = dir
tail = ""
stop = False
while tail != "Signal Scripts":
    count = count+1
    dir = head
    head, tail = os.path.split(head)
    if count >10:
        stop = True
        c4d.gui.MessageDialog("Error with Signal.\nPlease try to reinstall the scripts.")
        break 

try:
	api = imp.load_source('Functions.txt',os.path.join(dir,"res", "Functions.txt"))
	ID = imp.load_source('Ids.txt',os.path.join(dir,"res", "Ids.txt"))
except:
	stop = True
	c4d.gui.MessageDialog("Error with Signal.\nPlease try to reinstall the scripts.")
        

def main():
    if stop == True:
        return
    
    
    
    tags = doc.GetActiveTags()
    signals = []
    for tag in tags:
	if tag.GetType()==ID.SIGNAL:
		signals.append(tag)
    tags = signals
    if len(tags) <1: return
    place = 0
    random.seed(time.time())
    doc.StartUndo()
    for tag in tags:
        doc.AddUndo(c4d.UNDOTYPE_CHANGE_SMALL, tag)
        if tag.GetType()!=ID.SIGNAL: continue 
        place+=1
        
        
        
        
        #Start Here
        noises = api.GetTabs(tag,ID.Noise)#Gets all Sin tabs     tag, then the type of tab
        #all = mod.GetTabs(tag)#Gets all tabs
        for noise in noises:
            SeedId = api.GetId(tag,ID.ModNoiseSeed,noise)
            tag[SeedId] = random.randrange(0, 99999)
        #api.GetId(tag, 2015,sins[0])# get the id for that tab, tag, id for the parameter and then then the tab
        #api.GetVariationId(tag,3)# get the id for the variation paramters, tag then id for the base tab
        #api.GetVariationId(tag,3,[1])# get the id for the variation paramters, tag,  id, then the tab 
        # then do standard python stuff to the list and whatevers
        
        #for sin in sins:
            
        #    tag[id.GetVariationId(tag,mod.GetVariationId,sin)[1]] =  tag[id.GetVariationId(tag,mod.GetVariationId,sin)[1]] *2
            
        
        
        
        #End here   
    c4d.EventAdd()
    doc.EndUndo()
    
    
    
if __name__=='__main__':
    main()
